<template>
  <div>
    <div class="tbbd-list" v-show="!showDetail && !showEdit && !showAudit && !showFh">
      <div class="tbbd-search">
        <el-form :model="searchForm" ref="searchForm" :inline="true" label-width="110px">
          <el-row>
            <el-col :span="6">
              <el-form-item :label="$t('page.business.form.bdmc')" prop="name">
                <el-input v-model="searchForm.bdmc" :placeholder="$t('form.placeholderInput')" clearable
                  style="width: 200px"  />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item :label="$t('page.business.form.bdbh')" prop="sn">
                <el-input v-model="searchForm.bdbh" :placeholder="$t('form.placeholderInput')" clearable
                  style="width: 200px" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item :label="$t('page.business.form.gsr')" prop="userId">
                <SelectDeptUser v-model="searchForm.userId" style="width: 200px" :name="searchForm.userMc" key="userId"
                  @change="userChange" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item>
                <div style="margin-left: 100px;">
                  <el-button type="primary" icon="el-icon-search" @click="search">{{ $t('form.search') }}</el-button>
                  <el-button icon="el-icon-refresh" @click="reset">{{ $t('form.reset') }}</el-button>
                </div>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="6">
              <el-form-item :label="$t('page.business.form.xtmbmc')" prop="templateName">
                <el-input v-model="searchForm.templateMc" :placeholder="$t('form.placeholderInput')" clearable
                  style="width: 200px"  />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item :label="$t('page.business.form.cjsj')">
                <el-date-picker v-model="daterange" clearable type="daterange" range-separator="-"
                  :start-placeholder="$t('page.business.form.startDate')"
                  :end-placeholder="$t('page.business.form.endDate')" value-format="yyyy-MM-dd" 
                  style="width: 200px" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item :label="$t('page.business.form.tjsj')">
                <el-date-picker v-model="daterangetj" clearable type="daterange" range-separator="-"
                  :start-placeholder="$t('page.business.form.startDate')"
                  :end-placeholder="$t('page.business.form.endDate')" value-format="yyyy-MM-dd" 
                  style="width: 200px" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item :label="$t('page.business.study.studyFormFill.sfbl')">
                <el-select v-model="searchForm.sfbl" :placeholder="$t('form.placeholderSelect')" clearable
                  >
                  <el-option :label="$t('page.business.study.studyFormFill.yes')" value="是" />
                  <el-option :label="$t('page.business.study.studyFormFill.no')" value="否" />
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>
        </el-form>
      </div>
      <div class="tbbd-content">
        <el-row class="add-box">
          <el-col>
            <el-button type="primary" icon="el-icon-plus" v-if="isMatchSubject" @click="add()"
              v-hasPermi="['business:studyFormFill:xz']">{{
                $t('page.business.study.studyFormFill.xzbd') }}</el-button>
          </el-col>
        </el-row>

        <el-table v-loading="loading" :data="list">
          <el-table-column :label="$t('page.business.form.bh')" prop="bdbh" :show-overflow-tooltip="true" />
          <el-table-column :label="$t('page.business.form.bdmc')" prop="bdmc" :show-overflow-tooltip="true" />
          <el-table-column :label="$t('page.business.form.xtmbmc')" prop="templateMc" :show-overflow-tooltip="true" />
          <el-table-column :label="$t('page.business.form.cjsj')" align="center" prop="createTime" width="140" />
          <el-table-column :label="$t('page.business.form.gsr')" align="center" prop="userMc" width="100" />
          <el-table-column :label="$t('page.business.form.status')" prop="status" align="center" width="150">
            <template slot-scope="scope">
              <span v-if="scope.row.bdzt === 1"><span class="status-circle tbz"></span>{{ $t('page.business.study.studyFormFill.tbz') }}</span>
              <span v-if="scope.row.bdzt === 3"><span class="status-circle ytj"></span>{{ $t('page.business.study.studyFormFill.ytj') }}</span>
              <span v-if="scope.row.bdzt === 5"><span class="status-circle ywcfh"></span>{{ $t('page.business.study.studyFormFill.ywcfh') }}</span>
              <span v-if="scope.row.bdzt === 7"><span class="status-circle ywc"></span>{{ $t('page.business.study.studyFormFill.ywc') }}</span>
              <span v-if="scope.row.bdzt === 9"><span class="status-circle dfz"></span>{{ $t('page.business.study.studyFormFill.dfz') }}</span>
              <span v-if="scope.row.bdzt === 11"><span class="status-circle yfz"></span>{{ $t('page.business.study.studyFormFill.yfz') }}</span>
            </template>
          </el-table-column>
          <el-table-column :label="$t('page.business.study.studyFormFill.sfbl')" align="center" prop="status"
            width="100">
            <template slot-scope="scope">
              <span v-if="scope.row.sfbl === '是'"><span class="status-circle yes"></span>{{ $t('page.business.study.studyFormFill.yes') }}</span>
              <span v-if="scope.row.sfbl === '否'"><span class="status-circle no"></span>{{ $t('page.business.study.studyFormFill.no') }}</span>
            </template>
          </el-table-column>
          <el-table-column :label="$t('page.business.form.tjsj')" align="center" prop="tjsj" width="140" />
          <el-table-column :label="$t('form.operate')" align="left" fixed="right" width="200">
            <template slot-scope="scope">
              <!-- 表单状态：1：填报中；3：已提交；5：已完成（经复核）；7：已完成；9：待废止；11：已废止 -->
              <!-- 详情 -->
              <el-button type="text" @click="detail(scope.row)" v-hasPermi="['business:studyFormFill:xq']">{{
                $t('form.detail') }}</el-button>
              <!-- 编辑 -->
              <el-button type="text"
                v-if="(scope.row.bdzt === 1 || scope.row.bdzt === 5 || scope.row.bdzt === 7) && id == scope.row.userId"
                @click="edit(scope.row)" v-hasPermi="['business:studyFormFill:bj']">{{
                  $t('form.edit') }}</el-button>
              <!-- 复核 -->
              <el-button type="text" v-if="scope.row.bdzt === 3 && isMatchSubject&&id!=scope.row.userId" @click="fh(scope.row)"
                v-hasPermi="['business:studyFormFill:fh']">{{
                  $t('page.business.study.studyFormFill.fh') }}</el-button>
              <!-- 加签 -->
              <el-button type="text" v-if="scope.row.bdzt === 1 && isMatchSubject" @click="jq(scope.row)"
                v-hasPermi="['business:studyFormFill:jq']">{{
                  $t('page.business.study.studyFormFill.jq') }}</el-button>
              <!-- 更换归属人 -->
              <el-button type="text"
                v-if="(scope.row.bdzt === 1 || scope.row.bdzt === 3 || scope.row.bdzt === 5 || scope.row.bdzt === 7) && id == scope.row.subjectLeader"
                @click="ghgsr(scope.row)" v-hasPermi="['business:studyFormFill:ghgsr']">{{
                  $t('page.business.study.studyFormFill.ghgsr') }}</el-button>
              <!-- 审阅 -->
              <el-button type="text" v-if="(scope.row.bdzt === 5 || scope.row.bdzt === 7) && (isQa || id == leader)"
                @click="sy(scope.row)" v-hasPermi="['business:studyFormFill:sy']">{{
                  $t('page.business.study.studyFormFill.sy') }}</el-button>
              <!-- 废止 -->
              <el-button type="text" v-if="scope.row.bdzt === 1 && id == scope.row.userId" @click="fz(scope.row)"
                v-hasPermi="['business:studyFormFill:fz']">{{
                  $t('page.business.study.studyFormFill.fz') }}</el-button>
              <!-- 确认废止 -->
              <el-button type="text" v-if="scope.row.bdzt === 9 && id == leader" @click="qrfz(scope.row)"
                v-hasPermi="['business:studyFormFill:qrfz']">{{
                  $t('page.business.study.studyFormFill.qrfz') }}</el-button>
              <!-- 观察 todo 观察按钮只在系统模板为细胞复苏记录表才展示) -->
              <el-button type="text" v-if="scope.row.bdzt === 1&&scope.row.showGc==10" @click="gc(scope.row)"
                v-hasPermi="['business:studyFormFill:gc']">{{
                  $t('page.business.study.studyFormFill.gc') }}</el-button>
            </template>
          </el-table-column>
        </el-table>

        <pagination v-show="total > 0" :total="total" :page.sync="searchForm.pageNum" :limit.sync="searchForm.pageSize"
          @pagination="getList" />
      </div>
    </div>
    <!-- 编辑 -->
    <Bj v-show="showEdit" key="Bj" ref="Bj" @close="bjClose" />
    <!-- 详情 -->
    <Xq v-show="showDetail" key="Xq" ref="Xq" @close="xqClose" />
    <!-- 审阅 -->
    <Sy v-show="showAudit" key="Sy" ref="Sy" @close="syClose" />
    <!-- 复核 -->
    <Fh v-show="showFh" key="Fh" ref="Fh" @close="fhClose" />
    <!-- 废止 -->
    <Fz key="Fz" ref="Fz" @callback="search" />
    <!-- 确认废止 -->
    <Qrfz key="Qrfz" ref="Qrfz" @callback="search" />
    <!-- 加签 -->
    <Jq key="Jq" ref="Jq" @callback="search" />
    <!-- 观察 -->
    <Gc key="Gc" ref="Gc" @callback="search" />
    <!-- 更换归属人 -->
    <Ghgsr key="Ghgsr" ref="Ghgsr" @callback="search" />
    <SelectDeptUserDialog ref="selectDeptUserDialog" @change="ghgsrChange" />
  </div>

</template>

<script>
import { studySubject_isMatchSubject, studySubject_isQa } from "@/api/business/study/studySubject"
import { studyMethod_getReadAllMethodStatus } from '@/api/business/study/studyMethod'
import { studyFormFill_list } from '@/api/business/study/studyFormFill'
import Bj from "./tbbd/Bj";
import Xq from "./tbbd/Xq";
import Sy from "./tbbd/Sy";
import Fz from "./tbbd/Fz";
import Fh from "./tbbd/Fh";
import Qrfz from "./tbbd/Qrfz";
import Jq from "./tbbd/Jq";
import Ghgsr from "./tbbd/Ghgsr";
import Gc from "./tbbd/Gc";
import SelectDeptUser from '@/views/business/comps/select/SelectDeptUser';
import SelectDeptUserDialog from '@/views/business/comps/select/SelectDeptUserDialog';
import { caesarCipher } from "@/utils/index";
import { mapGetters } from 'vuex'
import moment from "moment";
export default {
  name: 'YtbdList',
  props: {
    study: {
      type: Object,
      default: () => {
        return {}
      }
    }
  },
  computed: {
    ...mapGetters([
      'id'
    ]),
  },
  watch: {
    study: {
      handler(newVal) {
        this.searchForm.studySn = newVal.sn
        this.searchForm.studyMc = newVal.name
        this.searchForm.studyId = newVal.id
        this.searchForm.studySubjectId = newVal.studySubjectId
        this.leader = newVal.leader
        this.getIsMatchSubject()
        this.search()
      },
      immediate: true,
      deep: true
    }
  },
  components: { Ghgsr, Fh, Fz, Bj, Xq, Qrfz, Sy, Jq, Gc, SelectDeptUser, SelectDeptUserDialog },
  data() {
    return {
      isMatchSubject: false,
      isQa: false,
      leader: null,
      showFh: false,
      showAudit: false,
      showEdit: false,
      showDetail: false,
      daterangetj: [],
      daterange: [],
      searchForm: {
        pageNum: 1,
        pageSize: 10,
        studyId: '',
        studySn: '',
        studyMc: '',
        studySubjectId: '',
        bdbh: '',
        bdmc: '',
        userId: '',
        userMc: '',
        templateMc: '',
        cjsjjs: '',
        sfbl:null,
        cjsjks: '',
        tjsjjs: '',
        tjsjks: '',
      },
      loading: false,
      total: 0,
      list: [],
      currentRow: null
    }
  },
  created() {
    this.getIsQa()
  },
  methods: {
    getIsMatchSubject() {
      studySubject_isMatchSubject({ studySubjectId: this.searchForm.studySubjectId }).then(response => {
        this.isMatchSubject = response.data
      })
    },
    getIsQa() {
      studySubject_isQa().then(response => {
        this.isQa = response.data
      })
    },
    ghgsr(row) {
      this.$modal.loading()
      studyMethod_getReadAllMethodStatus({ userId: this.id, studyId: this.searchForm.studyId }).then(response => {
        this.currentRow = row
        this.$refs.selectDeptUserDialog.show(null, null)
      }).finally(() => {
        this.$modal.closeLoading()
      })
    },
    ghgsrChange(val) {
      this.$refs.Ghgsr.show({ id: this.currentRow.id, userId: val.id, userMc: val.name })
    },
    jq(row) {
      this.$modal.loading()
      studyMethod_getReadAllMethodStatus({ userId: this.id, studyId: this.searchForm.studyId }).then(response => {
        this.$refs.Jq.show(row)
      }).finally(() => {
        this.$modal.closeLoading()
      })
    },
    qrfz(row) {
      this.$modal.loading()
      studyMethod_getReadAllMethodStatus({ userId: this.id, studyId: this.searchForm.studyId }).then(response => {
        this.$refs.Qrfz.show(row)
      }).finally(() => {
        this.$modal.closeLoading()
      })
    },
    gc(row) {
      this.$modal.loading()
      studyMethod_getReadAllMethodStatus({ userId: this.id, studyId: this.searchForm.studyId }).then(response => {
        this.$refs.Gc.show(row)
      }).finally(() => {
        this.$modal.closeLoading()
      })
    },
    fz(row) {
      this.$modal.loading()
      studyMethod_getReadAllMethodStatus({ userId: this.id, studyId: this.searchForm.studyId }).then(response => {
        this.$refs.Fz.show(row)
      }).finally(() => {
        this.$modal.closeLoading()
      })
    },
    userChange(val) {
      this.searchForm.userId = val.id
      this.searchForm.userMc = val.name
    },
    search() {
      this.searchForm.pageNum = 1
      this.getList()
    },
    reset() {
      this.searchForm.bdbh = ''
      this.searchForm.bdmc = ''
      this.searchForm.userId = ''
      this.searchForm.userMc = ' '
      this.searchForm.templateMc = ''
      this.searchForm.cjsjjs = ''
      this.searchForm.cjsjks = ''
      this.searchForm.tjsjjs = ''
      this.searchForm.tjsjks = ''
      this.searchForm.sfbl = null
      this.daterange=[]
      this.daterangetj=[]
      this.search()
    },
    getList() {
      if (this.daterange != null && this.daterange.length > 0) {
        this.searchForm.cjsjks = this.daterange[0]
        this.searchForm.cjsjjs = moment().add(this.daterange[1], 'days').format('YYYY-MM-DD');
      } else {
        this.searchForm.cjsjks = ''
        this.searchForm.cjsjjs = ''
      }
      if (this.daterangetj != null && this.daterangetj.length > 0) {
        this.searchForm.tjsjks = this.daterangetj[0]
        this.searchForm.tjsjjs = moment().add(this.daterangetj[1], 'days').format('YYYY-MM-DD');
      } else {
        this.searchForm.tjsjks = ''
        this.searchForm.tjsjjs = ''
      }
      this.loading = true
      studyFormFill_list(this.searchForm).then(response => {
        this.list = response.rows
        this.total = response.total
        this.loading = false
      })
    },
    add() {
      // this.showEdit = true
      // this.$emit('showDetail', this.showEdit)
      // this.$refs.Bj.edit({ studySn:this.searchForm.studySn, studyMc:this.searchForm.studyMc,studyId: this.searchForm.studyId, studySubjectId: this.searchForm.studySubjectId })
      this.$modal.loading()
      studyMethod_getReadAllMethodStatus({ userId: this.id, studyId: this.searchForm.studyId, studySubjectId: this.searchForm.studySubjectId }).then(response => {
        let params = caesarCipher(JSON.stringify({
          url: this.$route.fullPath,
          studyId: this.searchForm.studyId,
          id: null
        }))
        this.$tab.openPage(this.$t('page.business.study.studyFormFill.xzbd'), '/study/formFillBj/' + params)
      }).finally(() => {
        this.$modal.closeLoading()
      })
    },
    edit(row) {
      // this.showEdit = true
      // this.$emit('showDetail', this.showEdit)
      // this.$refs.Bj.edit(row)
      this.$modal.loading()
      studyMethod_getReadAllMethodStatus({ userId: this.id, studyId: this.searchForm.studyId, studySubjectId: this.searchForm.studySubjectId }).then(response => {
        let params = caesarCipher(JSON.stringify({
          url: this.$route.fullPath,
          studyId: this.searchForm.studyId,
          formId: row.id
        }))
        this.$tab.openPage(row.bdmc, '/study/formFillBj/' + params)
      }).finally(() => {
        this.$modal.closeLoading()
      })
    },
    bjClose() {
      this.showEdit = false
      this.$emit('showDetail', this.showEdit)
      this.search()
    },
    xqClose() {
      this.showDetail = false
      this.$emit('showDetail', this.showDetail)
      this.search()
    },
    syClose() {
      this.showAudit = false
      this.$emit('showDetail', this.showAudit)
      this.search()
    },
    fhClose() {
      this.showFh = false
      this.$emit('showDetail', this.showFh)
      this.search()
    },
    detail(row) {
      this.showDetail = true
      this.$emit('showDetail', this.showDetail)
      this.$refs.Xq.show(row)
    },
    sy(row) {
      this.showAudit = true
      this.$emit('showDetail', this.showAudit)
      this.$refs.Sy.show(row)
    },
    fh(row) {
      this.$modal.loading()
      studyMethod_getReadAllMethodStatus({ userId: this.id, studyId: this.searchForm.studyId, studySubjectId: this.searchForm.studySubjectId }).then(response => {
        this.showFh = true
        this.$emit('showDetail', this.showFh)
        this.$refs.Fh.show(row)
      }).finally(() => {
        this.$modal.closeLoading()
      })
    },
  }
}
</script>
<style lang="scss" scoped>
.tbbd-list {
  .tbbd-search {
    background: #fff;
    padding: 20px;
    margin-bottom: 10px;

    .right-btn {
      text-align: right
    }
  }

  .tbbd-content {
    padding: 20px;
    background: #fff;

    .add-box {
      margin-bottom: 10px;
    }
  }
}
</style>
